
// Field Probe ExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Field Probe Example.h"
#include "Field Probe ExampleDlg.h"
#include "afxdialogex.h"
#include <string>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

using namespace std;

// CFieldProbeExampleDlg dialog



CFieldProbeExampleDlg::CFieldProbeExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(IDD_FIELDPROBEEXAMPLE_DIALOG, pParent)
	, numX(0)
	, numY(0)
	, numZ(0)
	, numC(0)
	, chkStatusOK(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFieldProbeExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_ADDRESS, txtAddress);
	DDX_Control(pDX, IDC_MODEL, txtModel);
	DDX_Control(pDX, IDC_SERIAL, txtSerial);
	DDX_Control(pDX, IDC_FIRMWARE, txtFirmware);
	DDX_Control(pDX, IDC_LINEARIZATION, txtLinearization);
	DDX_Text(pDX, IDC_XDATA, numX);
	DDX_Text(pDX, IDC_YDATA, numY);
	DDX_Text(pDX, IDC_ZDATA, numZ);
	DDX_Text(pDX, IDC_CDATA, numC);
	DDX_Check(pDX, IDC_STATUSOK, chkStatusOK);
	DDX_Control(pDX, IDC_READ, btnRead);
}

BEGIN_MESSAGE_MAP(CFieldProbeExampleDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_INITIALIZE, &CFieldProbeExampleDlg::OnBnClickedInitialize)
	ON_BN_CLICKED(IDC_READ, &CFieldProbeExampleDlg::OnBnClickedRead)
	ON_WM_CLOSE()
END_MESSAGE_MAP()


// CFieldProbeExampleDlg message handlers

BOOL CFieldProbeExampleDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Initialize the address to a valid GPIB resource
	txtAddress.SetWindowText(TEXT("GPIB::4::INSTR"));

	btnRead.EnableWindow(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFieldProbeExampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFieldProbeExampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CFieldProbeExampleDlg::OnBnClickedInitialize()
{
	CString address;
	txtAddress.GetWindowText(address);

	fp.Close();

	// Initialize a new session
	if (fp.Initialize(string(address)) == 0)
	{
		// Query information about the attached probe
		ProbeID probe = fp.QueryProbeID();
		txtModel.SetWindowText(probe.model.c_str());
		txtSerial.SetWindowText(probe.serial.c_str());
		txtFirmware.SetWindowText(probe.firmware.c_str());
		txtLinearization.SetWindowText(probe.linearization.c_str());

		// Enable the read button
		btnRead.EnableWindow(TRUE);
	}
}


void CFieldProbeExampleDlg::OnBnClickedRead()
{
	// Take a reading from the probe
	ProbeData data = fp.ReadData();

	// Fill data from the returned ProbeData struct
	numX = data.x;
	numY = data.y;
	numZ = data.z;
	numC = data.c;
	chkStatusOK = data.statusOK;

	UpdateData(false);
}


void CFieldProbeExampleDlg::OnClose()
{
	// Close the VISA session
	fp.Close();

	CDialogEx::OnClose();
}
